<template>
  <div
    class="order-card-status-block"
  >
    <div class="order-card-status-block__text">
      <template v-if="isClient">
        <template v-if="currentStatus === 'NEW'">
          Поиск...
        </template>
        <template v-if="currentStatus === 'ON_DOER_SEARCH'">
          Поиск исполнителя...
        </template>
        <template v-if="currentStatus === 'BOOKED'">
          Назначение ресурсов...
        </template>
        <template v-if="currentStatus === 'ALLOCATED'">
          Ожидание подписания заявки...
        </template>
        <template v-if="currentStatus === 'CONTRACTED'">
          <span class="-caribbean-green">Заявка подписана</span>
          <br>
          <span class="--color-grey-span">ПВП через <ObCountdown ref="countdown" :to-date="currentSubOrder.pvpDt"/></span>
        </template>
        <template v-if="currentStatus === 'IN_PROCESS'">
          Исполнение рейса
        </template>
        <template v-if="['PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID'].includes(currentStatus)">
          <span class="-caribbean-green">Рейс исполнен</span>
        </template>
      </template>

      <template v-else>
        <template v-if="currentStatus === 'NEW'">
          <span v-if="!isCountdownFinished()">Поиск исполнителей начнется через</span>
          <ObCountdown
            ref="countdown"
            :duration="subOrderTimeValue"
            finished-text="формируются запросы"
            @finished="finished"
          />
        </template>
        <template v-if="currentStatus === 'ON_DOER_SEARCH'">
          <template v-if="isCountdownFinished()">
            <span class="-light-raspberry-red">ПВП через <ObCountdown :to-date="currentSubOrder.pvpDt"/></span><br>
          </template>
          <template v-else>
            <span></span>Поиск исполнителя с лучшей ценой<br>
            <span class="--color-grey-span">До окончания поиска</span>
            <!--            Поиск исполнителя ({{ isNegativeTime ? 'букинг' : 'аукцион' }})-->
          </template>
          <ObCountdown
            ref="countdown"
            :duration="subOrderTimeValue"
            finished-text="Поиск исполнителя с лучшей ценой..."
            @finished="finished"
          />
        </template>
        <template v-if="currentStatus === 'BOOKED'">
          <span class="-caribbean-green">Букинг запрос подтвержден.</span>
          <br>

          <span v-if="!isCountdownFinished()" class="--color-grey-span">Назначение ресурсов</span>
          <ObCountdown
            ref="countdown"
            :duration="subOrderTimeValue"
            finished-text="формируются запросы"
            @finished="finished"
          />
        </template>
        <template v-if="currentStatus === 'ALLOCATED'">
          Ожидание подписания заявки исполнителем<br>
          <ObCountdown
            :duration="subOrderTimeValue"
            finished-text="формируются запросы"
            @finished="finished"
          />
        </template>
        <template v-if="currentStatus === 'CONTRACTED'">
          <span class="-caribbean-green">Заявка подписана</span>
          <br>
          <span class="--color-grey-span">ПВП через <ObCountdown ref="countdown" :to-date="currentSubOrder.pvpDt"/></span>
        </template>
        <template v-if="currentStatus === 'IN_PROCESS'">
          На маршруте
        </template>
        <template v-if="['PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID'].includes(currentStatus)">
          <span class="-caribbean-green">Исполнен</span>
        </template>
      </template>
    </div>
    <div class="order-card-status-block__icon">
      <template v-if="['PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID'].includes(currentStatus)">
        <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path fill-rule="evenodd" clip-rule="evenodd" d="M2.71236 3.6438L6.53487 14.6004L5.40509 15L1.58259 4.04343L2.71236 3.6438Z" fill="#0FB785"/>
          <path d="M14.439 1L13.5567 1.77155C13.5567 1.77155 12.2622 2.83827 10.9706 2.83827C10.3814 2.83827 9.91125 2.59862 9.32206 2.3619C8.67482 2.06672 7.91148 1.65172 6.79404 1.65172C3.61587 1.65172 1.79315 3.6069 1.67415 3.72672L1.5 3.90207L4.55916 12.5498L5.20351 11.8981C5.20351 11.8981 6.61699 10.4778 8.02757 10.4778C8.90991 10.4778 9.44106 10.656 9.91125 10.7729C10.3814 10.8928 10.8516 11.071 11.5569 11.071C12.9704 11.071 14.1459 10.4193 14.204 10.4193L14.5 10.241L14.439 1ZM13.3216 9.53087C12.9704 9.70622 12.2622 9.94586 11.4989 9.94586C10.9706 9.94586 10.6165 9.82604 10.1464 9.70622C9.55716 9.53086 8.97086 9.35259 7.91148 9.35259C6.73309 9.35259 5.61565 10.0628 4.96841 10.5362L2.79448 4.20017C3.32273 3.72672 4.73331 2.71845 6.85209 2.71845C7.67638 2.71845 8.26267 3.01362 8.90991 3.31172C9.55716 3.6069 10.1464 3.90207 11.0287 3.90207C11.911 3.90207 12.7934 3.54845 13.3826 3.1919V9.53087H13.3216Z" fill="#0FB785"/>
          <path d="M2.14748 4.02189C2.14748 4.02189 3.02982 3.07498 4.26335 2.65999L5.20374 5.02724C5.20374 5.02724 4.02825 5.44223 3.02982 6.39206L2.14748 4.13879V4.02189ZM5.14569 5.08861L6.14703 7.63413C6.14703 7.63413 6.91037 7.33896 7.44151 7.33896C7.96976 7.33896 8.498 7.39741 8.498 7.39741L7.79271 4.67361C7.79271 4.67361 7.61566 4.67361 7.32252 4.67361C6.14703 4.67361 5.14569 5.08861 5.14569 5.08861ZM3.97021 9.11586L4.7945 11.4831C4.7945 11.4831 5.96998 10.3579 7.02937 10.0628L6.08608 7.63413C5.08764 8.04913 3.97021 9.11586 3.97021 9.11586Z" fill="#0FB785"/>
          <path d="M7.1451 2.18654L7.79271 4.67361C8.32385 4.67361 9.79212 5.38379 9.79212 5.38379L9.20583 2.77689C8.90978 2.71844 8.02744 2.24499 7.1451 2.18654ZM8.49764 7.45586L9.20583 10.0628C9.55703 10.0628 10.5584 10.4778 10.9705 10.4778L10.3813 7.92931C9.79212 7.75396 8.90978 7.45586 8.49764 7.45586ZM9.79212 5.44224L10.3233 7.87086C10.3233 7.87086 10.8515 7.99069 11.2637 7.99069C11.6758 7.99069 12.146 7.92931 12.146 7.92931L11.9689 5.67897C11.9689 5.67897 11.6178 5.79879 11.1447 5.79879C10.4974 5.79879 9.79212 5.44224 9.79212 5.44224ZM11.7919 3.25034L11.9689 5.67897C11.9689 5.67897 12.8513 5.44224 13.8526 4.67361V2.18654C12.7352 3.07499 11.7919 3.25034 11.7919 3.25034ZM12.146 7.92931C12.146 7.92931 13.0283 7.75396 13.8526 7.28051V9.94586C12.9703 10.3579 12.323 10.4778 12.323 10.4778L12.146 7.92931Z" fill="#0FB785"/>
        </svg>
      </template>
      <template v-else>
        <span v-html="statusIcon" />
      </template>

    </div>
  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import ObCountdown from "common-components/src/obComponents/obCountdown"

  export default {
    name: 'OrderItemStatusBlock',
    components: {
      ObCountdown
    },
    props: {
      uuid: {
        type: String,
        required: true
      }
    },
    data () {
      return {
        orderStatuses: {
          NEW: {
            icon: 'clock'
          },
          BOOKED: {
            icon: 'checked',
            iconColor: '#10CF96'
          },
          ALLOCATED: {
            icon: 'clock'
          },
          ON_DOER_SEARCH: {
            icon: 'clock'
          },
          CONTRACTED: {
            icon: 'double-checked',
            iconColor: '#10CF96'
          },
          IN_PROCESS: {
            icon: 'refresh'
          },
          PROCESSED: {
            icon: 'flag-finish',
            iconColor: '#10CF96'
          }
        }
      }
    },
    computed: {
      ...mapGetters({
        subOrder: 'order/subOrder',
        subOrderTime: 'order/subOrderTime',
        selectedTrip: 'order/selectedTrip',
        isClient: 'user/isClient',
        isClicar: 'user/isClicar',
      }),
      currentSubOrder () {
        if (this.isClicar && !this.selectedTrip) {
          return this.subOrder[this.uuid] || {}
        } else {
          return this.selectedTrip ? this.subOrder[this.selectedTrip.uuid] : {}
        }
      },
      currentStatus () {
        if (this.isClient || (this.currentSubOrder && this.currentSubOrder.status && ['CONTRACTED', 'IN_PROCESS', 'PROCESSED', 'PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID', 'CANCELED'].includes(this.currentSubOrder.status))) {
          return this.currentSubOrder && this.currentSubOrder.status
        }
        return this.subOrderTime && this.subOrderTime.status
      },
      statusIcon () {
        if (!this.orderStatuses[this.currentStatus]) return null

        let icon = this.orderStatuses[this.currentStatus].icon
        let color = this.orderStatuses[this.currentStatus].iconColor || '#0070A6'

        if (this.isCountdownFinished() && this.currentStatus === 'ON_DOER_SEARCH') {
          return `<i class="icon alert -light-raspberry-red" />`
        }

        return `<i class="icon ${icon}" style="color: ${color}" />`
      },
      isNegativeTime () {
        return this.subOrderTime && this.subOrderTime.timeBefore && this.subOrderTime.timeBefore < 0
      },
      subOrderTimeValue () {
        let time = this.subOrderTime && this.subOrderTime.timeBefore

        if (['BOOKED', 'ALLOCATED'].includes(this.currentStatus) && time < 0) {
          time = 0
        }

        return time ? Math.abs(time * 60) : 0
      }
    },
    methods: {
      ...mapActions({
        getSubOrder: 'order/getSubOrder'
      }),
      finished () {
        this.getSubOrder({ uuid: this.currentSubOrder.uuid, setLoading: false, timeout: 500 })
      },
      isCountdownFinished () {
        return this.$refs.countdown && this.$refs.countdown.finished
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "../../../../../node_modules/common-components/src/static/css/mixins";
  @import "../../../../../node_modules/common-components/src/static/css/variables";

  .order-card-status-block {
    display: flex;
    justify-content: flex-end;
    align-items: center;
    text-align: right;
    &__text {
      @include font-mixin(12px, 16px, 400, $color-text-base, 0.4px);
    }
    &__icon {
      width: 25px;
      font-size: 24px;
      margin-left: 5px;
      .icon {
        color: $color-blue-navy-blue;
      }
    }
    &::v-deep {
      .ob-countdown {
        margin-left: 3px;
        color: $color-grey-span;
      }
    }
    .--color-grey-span {
      color: $color-grey-span;
    }
  }
</style>
